/*
 * Copyright (c) 2016, The Linux Foundation. All rights reserved.
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 and only version 2 as published by the Free Software
 * Foundation. This program is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details. 
 */
/*****************************************************************************/
// Module Name: 
//    strutils.h
//
// Abstract: 
//   
// 
// Notes:
//    
//
/*****************************************************************************/

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#ifndef _STR_UTILS_H_
#define _STR_UTILS_H_

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#include <errno.h> 

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#define INVALID         1
#define TOOSMALL        2
#define TOOLARGE        3

#ifndef LLONG_MIN
#define LLONG_MIN     (-0x7fffffffffffffffLL-1)
#endif //LLONG_MIN

#ifndef LLONG_MAX
#define LLONG_MAX     0x7fffffffffffffffLL
#endif //LLONG_MAX

#ifndef LONG_MAX
#define LONG_MAX   2147483647L
#endif // LONG_MAX

#ifndef LONG_MIN
#define LONG_MIN   (-2147483647L - 1)
#endif //LONG_MIN

#ifndef ULONG_MAX
#define ULONG_MAX  4294967295UL
#endif //ULONG_MAX

#ifndef _STRTO_ERRNO
#define _STRTO_ERRNO 1
#endif //_STRTO_ERRNO

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

long strtonum(const char *numstr, int minval, int maxval,const char **errstrp);

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

unsigned int strtounum(const char *numstr, unsigned int minval, unsigned int maxval,const char **errstrp);

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#endif //_STR_UTILS_H_

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
